<?php
// Dynamic sitemap creator for Joomla
// This script creates a list of links (sections, categories, content items and all menu items)
// from Joomla to feed Google sitemaps with the latest informations
//
// by Mustafa Görmezer (http://www.goermezer.de)
//
// Date checking and W3C Datetime formatting by Diana Scherff,
// www.amas-veritas.com - Updated 03/05/07
// Also updated to most current preferred schema: 0.9 @ sitemaps.org
//
// Submission of Linked components by Kevin (kevin@saskma.com)
//
// Google ping after sitemap download and mail function by Mustafa Görmezer
include ('configuration.php');

// if the top line doesn't work and your configuration.php is elsewhere, comment
// it out and uncomment the line below and edit it with your correct file location:

//include('/home/user/yourdomain.com/www/html/configuration.php');

// Googles ping url. After getting sitemap a ping will be sent to this url:
$google_ping_url='http://www.google.com/webmasters/tools/ping?sitemap='.$mosConfig_live_site.'/sitemap.php';


header("Content-type: text/xml");
#header("Cache-Control: no-store, no-cache");
#header("Content-Disposition: attachment; filename=sitemap.txt");

$db = @mysql_connect($mosConfig_host,$mosConfig_user,$mosConfig_password)
      or die(mysql_error());
@mysql_select_db($mosConfig_db,$db) or die(mysql_error());

echo '<?xml version="1.0" encoding="UTF-8"?>';
echo '<?xml-stylesheet type="text/xsl" href="sitemap.xsl"?>';
echo '<urlset xmlns="http://www.sitemaps.org/schemas/sitemap/0.9" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xsi:schemaLocation="http://www.sitemaps.org/schemas/sitemap/0.9 http://www.sitemaps.org/schemas/sitemap/0.9/sitemap.xsd">';

//Main Site
echo '<url>';
echo '<loc>';
echo $mosConfig_live_site;
echo '</loc>';
echo '<priority>1.0</priority>';
echo '</url>';


$result = @mysql_query("SELECT id FROM ".$mosConfig_dbprefix."sections WHERE PUBLISHED='1'");
while($row = mysql_fetch_assoc($result)) {
    // Creating section links
    echo '<url>';
    echo '<loc>';
    if ($mosConfig_sef == '1' ){
    	echo htmlentities($mosConfig_live_site.'/content/section/'.$row['id']);
    }
    else{
    	echo htmlentities($mosConfig_live_site.'/index.php?option=com_content&task=section&id='.$row['id']);
    	}
    echo '</loc>';
    echo '<changefreq>monthly</changefreq>';
    echo '<priority>0.5</priority>';
    echo '</url>';
    $result2 = @mysql_query("SELECT id FROM ".$mosConfig_dbprefix."categories WHERE section='".$row['id']."' AND PUBLISHED='1'");
    while($row2 = mysql_fetch_assoc($result2)) {
        // Creating category links
        echo '<url>';
        echo '<loc>';
        if ($mosConfig_sef == '1' ){
        	echo htmlentities($mosConfig_live_site.'/content/category/'.$row2['id']);
        }
        else {
        	echo htmlentities($mosConfig_live_site.'/index.php?option=com_content&task=category&id='.$row2['id']);
        }
        echo '</loc>';
        echo '<changefreq>monthly</changefreq>';
        echo '<priority>0.6</priority>';
        echo '</url>';
        $TimeOffset = "$mosConfig_offset_user";
        if (ereg('^\+',"$TimeOffset")) {
          if (ereg('[0-9]{2}',"$TimeOffset")) {
            $offset = "$TimeOffset".':00';
          } else {
            $offset_hrs = eregi_replace('\+', '+0', "$TimeOffset");
            $offset = "$offset_hrs".':00';
          }
        } elseif (ereg('^\-',"$TimeOffset")) {
          if (ereg('[0-9]{2}',"$TimeOffset")) {
            $offset = "$TimeOffset".':00';
          } else {
            $offset_hrs = eregi_replace('\-', '-0', "$TimeOffset");
            $offset = "$offset_hrs".':00';
          }
        } elseif ($TimeOffset == '-0') {
          $offset = '+00:00';
        } else {
          $offset = '+00:00';
        }
        $result3=@mysql_query("SELECT id, created, modified FROM ".$mosConfig_dbprefix."content WHERE sectionid='".$row['id']."' AND catid='".$row2['id']."' AND ACCESS='0' ORDER BY modified DESC");
        while($row3 = mysql_fetch_assoc($result3)) {
            $created = $row3['created'];
            $modified = $row3['modified'];
            $body_c = eregi_replace('[ ]{1}', 'T', "$created");
            $body_m = eregi_replace('[ ]{1}', 'T', "$modified");
            // Creating section links
            if ($mosConfig_sef == '1' ){
            	echo '<url>';
            	echo '<loc>';
                echo htmlentities($mosConfig_live_site.'/content/view/'.$row3['id']);
                echo '</loc>';
                echo '<changefreq>weekly</changefreq>';
                echo '<priority>1.0</priority>';
                if ($row3['modified'] == '0000-00-00 00:00:00') {
                    echo '<lastmod>'.$body_c.$offset.'</lastmod>';
                }
                else {
                    echo '<lastmod>'.$body_m.$offset.'</lastmod>';
                }
                echo '</url>';

            }

            else{
            	  echo '<url>';
            	  echo '<loc>';
                echo htmlentities($mosConfig_live_site.'/index.php?option=com_content&task=view&id='.$row3['id']);
                echo '</loc>';
                echo '<changefreq>weekly</changefreq>';
                echo '<priority>1.0</priority>';
                if ($row3['modified'] == '0000-00-00 00:00:00') {
                    echo '<lastmod>'.$body_c.$offset.'</lastmod>';
                }
                else {
                    echo '<lastmod>'.$body_m.$offset.'</lastmod>';
                }
                echo '</url>';
            }
          }
        }
    }

    //Added to include static content items
    $result5=@mysql_query("SELECT id, modified FROM ".$mosConfig_dbprefix."content WHERE sectionid='0' and state='1' AND ACCESS='0' ORDER BY hits DESC");

    while($row = mysql_fetch_assoc($result5)) {
        $modified = $row['modified'];
        $body_m = eregi_replace('[ ]{1}', 'T', "$modified");
        // Creating static content links
        echo '<url>';
        echo '<loc>';
        if ($mosConfig_sef == '1' ){
            echo htmlentities($mosConfig_live_site.'/content/view/'.$row['id']);
           }
        else {
            echo htmlentities($mosConfig_live_site.'/index.php?option=com_content&task=view&id='.$row['id']);
            }
        echo '</loc>';
        echo '<changefreq>weekly</changefreq>';
        echo '<priority>0.7</priority>';
        echo '<lastmod>'.$body_m.$offset.'</lastmod>';
        echo '</url>';
    }

    /*
    //Added to include publicly accessible published components (by kevin@saskma.com)
    $result4 = @mysql_query("SELECT DISTINCT (j.option), m.id FROM ".$mosConfig_dbprefix."components AS j, ".$mosConfig_dbprefix."menu AS m WHERE m.componentid = j.id AND m.published = 1 and m.access=0 and m.menutype = 'mainmenu' and m.type = 'components'");

    while($row = mysql_fetch_assoc($result4)) {
    // Creating component links
        echo '<url>';
        echo '<loc>';
        if ($mosConfig_sef == '1' ){
            echo htmlentities($mosConfig_live_site.'/component/option,'.$row['option'].'/Itemid,'.$row['id']);
            }
        else {
            echo htmlentities($mosConfig_live_site.'/index.php?option='.$row['option'].'&task=view&id='.$row['id']);
            }
        echo '</loc>';
        echo '<changefreq>weekly</changefreq>';
        echo '<priority>0.8</priority>';
        echo '</url>';
    }
  */

    // Get all menu items
    $result5=@mysql_query("SELECT id, name, link, type FROM ".$mosConfig_dbprefix."menu WHERE published='1' AND ACCESS='0' ORDER BY name DESC");
    while($row5 = mysql_fetch_assoc($result5)) {
        if ($row5['link'] != '#' && $row5['type'] != 'url'){
            $result6=@mysql_query("SELECT id, name, link, type FROM ".$mosConfig_dbprefix."menu WHERE parent=".$row5['id']." AND published='1' AND ACCESS='0' ORDER BY name DESC");
            // Erste Ebene ausgeben
            echo '<url>';
            echo '<loc>';
            echo htmlentities($mosConfig_live_site.'/'.$row5['link']);
            echo '</loc>';
            echo '<changefreq>monthly</changefreq>';
            echo '<priority>0.9</priority>';
            echo '</url>';
        }

        while($row6 = mysql_fetch_assoc($result6)) {
            if ($row5['link'] != '#' && $row6['type'] != 'url'){
                // Zweite Ebene
                echo '<url>';
                echo '<loc>';
                echo htmlentities($mosConfig_live_site.'/'.$row6['link']);
                echo '</loc>';
                echo '<changefreq>monthly</changefreq>';
                echo '<priority>0.9</priority>';
                echo '</url>';
                }
        }
    }

mysql_free_result($result);
mysql_free_result($result2);
mysql_free_result($result3);
//mysql_free_result($result4);
mysql_free_result($result5);
mysql_free_result($result6);
echo '</urlset>';

// Now ping he search engine
// $out = file($google_ping_url);
?>
